require "semver_bump/version"
require "semver_bump/semver"
require "semver_bump/find"
require "semver_bump/version_file"


module SemverBump
  class Bump

    def initialize(path='.')
      @path = path
    end

    def version_file_path
      @version_file_path ||= Find.new(@path).version_file_path
    end

    def version_file
      @version_file ||= VersionFile.new(version_file_path)
    end 

    def current
      version_file.semver.to_s
    end

    SemVer::PARTS.each do |name|      
      define_method(:"#{name.to_s}") do
        version_file.send(:"bump_#{name.to_s}")
      end
    end

  end
end
