module SemverBump
  class VersionFile

    attr_accessor :semver

    LINE_MATCH = /^\s*VERSION\s*=\s*"?'?([.\d]*\.?[a-zA-Z]{0,4}[0-9]{0,3})"?'?\s*$/

    def initialize(filepath)
      @filepath = filepath
      setup
    end

    def setup
      @text = File.read(@filepath)
      @semver = SemVer.new(version_string)
    end

    SemVer::PARTS.each do |name|      
      define_method(:"bump_#{name.to_s}") do
        semver.send(:"bump_#{name.to_s}")
        replace
      end
    end

    def version_string
      LINE_MATCH.match(@text).captures.first  
    end

    def replace
      replace = @text.gsub(Regexp.new(version_string), semver.to_s)
      File.open(@filepath, "w") {|file| file.puts replace}
      semver.to_s
    end

  end
end